Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -5651,81 +6813,165 @@
       ENDIF  ! ( topography /= 'flat' )
 !
-!--   Apply the reversibility correction to the boundary-normal velocity-
-!--   component u and the scalars. It must not be applied to the boundary-
-!--   tangential velocity components v and w because their 2-D anterpolation
-!--   cells do not cover all the child-grid nodes on the boundary.
-      IF ( .NOT. ( ( var == 'v' ) .OR. ( var == 'w' ) ) )  THEN
-         l = ic(i)
-         DO  m = jcs, jcn
-            DO  n = 0, kct+1
-               ijk = 1
-               cellsum   = 0.0_wp
-               cellsumd  = 0.0_wp
-!
-!--            Note that the index name i must not be used here as a loop 
-!--            index name since i is the constant boundary index, hence 
-!--            the name ia. 
-               DO  ia = ifl(l), ifu(l)   
-                  DO  j = jfl(m), jfu(m)
-                     DO  k = kfl(n), kfu(n)
-                        cellsum = cellsum + MERGE( f(k,j,ia), 0.0_wp,           &
-                             BTEST( wall_flags_0(k,j,ia), var_flag ) )
-                        celltmpd(ijk) = ABS( fc(n,m,l) - f(k,j,ia) )
-                        cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
-                             0.0_wp, BTEST( wall_flags_0(k,j,ia), var_flag ) )
-                        ijk = ijk + 1
-                     ENDDO
+!--   Apply the reversibility correction. 
+
+!      if  ( var == 'u' )  then
+
+      l  = ic(ibc) + loff
+      lw = 1
+!      write(9,"('pmci_interp_tril_lr: edge, var, l, i, iend, ifl(l), ifu(l) = ',2(a2,2x),5(i4,2x))") &
+!           edge, var, l, i, iend, ifl(l), ifu(l)
+!      flush(9)
+!AH      DO  m = jcsw+1, jcnw-1       
+      DO  m = jcsw + 1, jcnw - mnorthv   ! mnorthv = 0 for v and 1 for all others
+         DO  n = 0, kct + ntopw            ! ntopw = 1 for w and 0 for all others
+            ijk = 1
+            cellsum   = 0.0_wp
+            cellsumd  = 0.0_wp
+!
+!--         Note that the index name i must not be used here as a loop 
+!--         index name since i is the constant boundary index, hence 
+!--         the name ia. 
+            DO  ia = ifl(l), ifu(l)
+               iaw = ia - i
+               iw  = MAX( MIN( ia, nx+1 ), -1 )
+               DO  j = jfl(m), jfu(m)
+                  jw = MAX( MIN( j, ny+1 ), -1 )
+                  DO  k = kfl(n), kfu(n)
+                     kw = MIN( k, nzt+1 )
+!AH
+!                     cellsum = cellsum + MERGE( f(k,j,ia), 0.0_wp,              &
+!                          BTEST( wall_flags_0(kw,jw,iw), var_flag ) )
+                     cellsum = cellsum + MERGE( workarr_lr(k,j,iaw), 0.0_wp,     &
+                          BTEST( wall_flags_0(kw,jw,iw), var_flag ) )
+!AH
+                     
+!AH                     celltmpd(ijk) = ABS( fc(n,m,l) - f(k,j,ia) )
+!AH                     celltmpd(ijk) = ABS( workarrc_lr(n,m,lw) - f(k,j,ia) )
+                     celltmpd(ijk) = ABS( workarrc_lr(n,m,lw) - workarr_lr(k,j,iaw) )
+                     cellsumd      = cellsumd  + MERGE( celltmpd(ijk),          &
+                          0.0_wp, BTEST( wall_flags_0(kw,jw,iw), var_flag ) )
+
+!                     write(9,"('lr1: ',a1,2x,8(i4,2x),5(e12.5,2x))") var, n, m, l, k, j, ia, iaw, ijk,  &
+!                          workarrc_lr(n,m,lw), workarr_lr(k,j,iaw), cellsum, celltmpd(ijk), cellsumd
+!                     flush(9)
+
+                     ijk = ijk + 1
                   ENDDO
                ENDDO
-
-               IF ( ijkfc(n,m,l) /= 0 )  THEN
-                  cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
-                  rcorr     = fc(n,m,l) - cellsum
-                  cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
-               ELSE
-                  cellsum   = 0.0_wp                  
-                  rcorr     = 0.0_wp
-                  cellsumd  = 1.0_wp
-                  celltmpd  = 1.0_wp
-               ENDIF
+            ENDDO
+
+            IF ( ijkfc(n,m,l) /= 0 )  THEN
+               cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+!               rcorr     = fc(n,m,l) - cellsum
+               rcorr     = workarrc_lr(n,m,lw) - cellsum
+               cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
+            ELSE
+               cellsum   = 0.0_wp                  
+               rcorr     = 0.0_wp
+               cellsumd  = 1.0_wp
+               celltmpd  = 1.0_wp
+            ENDIF
 ! 
-!--            Distribute the correction term to the child nodes according to 
-!--            their relative difference to the parent value such that the
-!--            node with the largest difference gets the largest share of the 
-!--            correction. The distribution is skipped if rcorr is negligibly 
-!--            small in order to avoid division by zero. 
-               IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
-                  cellsumd  = 1.0_wp
-                  celltmpd  = 1.0_wp
-               ENDIF
-
-               ijk = 1
-               DO  ia = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-                     DO  k = kfl(n), kfu(n)
-                        rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
-                        f(k,j,ia) = f(k,j,ia) + rcorr_ijk
-                        ijk = ijk + 1
-                     ENDDO
+!--         Distribute the correction term to the child nodes according to 
+!--         their relative difference to the parent value such that the
+!--         node with the largest difference gets the largest share of the 
+!--         correction. The distribution is skipped if rcorr is negligibly 
+!--         small in order to avoid division by zero. 
+            IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
+               cellsumd  = 1.0_wp
+               celltmpd  = 1.0_wp
+            ENDIF
+
+            ijk = 1
+            DO  ia = ifl(l), ifu(l)
+!AH               iaw = ia - ifl(l)
+               iaw = ia - i
+               DO  j = jfl(m), jfu(m)
+                  DO  k = kfl(n), kfu(n)
+                     rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+!AH                     f(k,j,ia) = f(k,j,ia) + rcorr_ijk
+                     workarr_lr(k,j,iaw) = workarr_lr(k,j,iaw) + rcorr_ijk
+
+!                     write(9,"('lr2: ',a1,2x,9(i4,2x),4(e12.5,2x))") var, n, m, l, k, j, ia, iaw, ijk, ijkfc(n,m,l), &
+!                          rcorr, rcorr_ijk, workarr_lr(k,j,iaw), workarrc_lr(n,m,lw)
+!                     flush(9)
+
+                     ijk = ijk + 1
                   ENDDO
                ENDDO
+            ENDDO
+!
+!--         Velocity components tangential to the boundary need special 
+!--         treatment because their anterpolation cells are flat in their 
+!--         direction and hence do not cover all the child-grid boundary nodes. 
+!--         These components are next linearly interpolated to those child-grid 
+!--         boundary nodes which are not covered by the anterpolation cells.
+            IF  ( ( var == 'w' ) .AND. ( n > 0 ) )  THEN
+               DO  k = kfu(n-1)+1, kfl(n)-1
+                  IF  ( k <= nzt )  THEN
+                     DO  j = jfl(m), jfu(m)
+                        IF  ( ( j >= nys ) .AND. ( j <= nyn+1 ) )  THEN
+!AH                              
+!                           f(k,j,ia) = r1z(k) * f(kfu(n-1),j,ia)                &
+!                                   + r2z(k) * f(kfl(n),j,ia)
+                           workarr_lr(k,j,iawbc) =                              &
+                                  r1z(k) * workarr_lr(kfu(n-1),j,iawbc)         &
+                                + r2z(k) * workarr_lr(kfl(n),j,iawbc)
+
+!                           write(9,"('lr3: ',a1,2x,7(i4,2x),3(e12.5,2x))") var, n, m, l, k, j, iawbc, ibc, &
+!                                workarr_lr(k-1,j,iawbc), workarr_lr(k,j,iawbc), workarr_lr(k+1,j,iawbc)
+!                           flush(9)
+
+!AH                              
+                        ENDIF
+                     ENDDO
+                  ENDIF
+               ENDDO
+            ENDIF
+
+            IF  ( ( var == 'v' ) .AND. ( m > jcsw ) )  THEN
+               DO  j = jfu(m-1)+1, jfl(m)-1
+                  IF  ( ( j >= nys ) .AND. ( j <= nyn+1 ) )  THEN
+                     DO  k = kfl(n), kfu(n)
+                        IF  ( k <= nzt+1 )  THEN                              
+!AH                              
+!                           f(k,j,ia) = r1y(j) * f(k,jfu(m-1),ia)                &
+!                                   + r2y(j) * f(k,jfl(m),ia)
+                           workarr_lr(k,j,iawbc) =                              &
+                                  r1y(j) * workarr_lr(k,jfu(m-1),iawbc)         &
+                                + r2y(j) * workarr_lr(k,jfl(m),iawbc)
+
+!                           write(9,"('lr4: ',a1,2x,7(i4,2x),3(e12.5,2x))") var, n, m, l, k, j, iawbc, ibc, &
+!                                workarr_lr(k,j-1,iawbc), workarr_lr(k,j,iawbc), workarr_lr(k,j+1,iawbc)
+!                           flush(9)
+
+!AH                              
+                        ENDIF
+                     ENDDO
+                  ENDIF
+               ENDDO
+            ENDIF
                
-            ENDDO  ! n
-         ENDDO  ! m
-         
-      ENDIF  ! var not v or w 
-!
-!--   Store the boundary values also into the other redundant ghost node layers.
-!--   Note that in case of only one ghost node layer, e.g. for the PW 
-!--   scheme, the following loops will not be entered.
-      IF ( edge == 'l' )  THEN
-         DO  ibgp = -nbgp, ib
-            f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
-         ENDDO
-      ELSEIF ( edge == 'r' )  THEN
-         DO  ibgp = ib, nx+nbgp
-            f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
-         ENDDO
-      ENDIF
+         ENDDO  ! n
+      ENDDO  ! m
+
+!      endif  ! var
+
+!
+!--   Finally substitute the boundary values.
+      f(nzb:nzt+1,nys:nyn,ibc) = workarr_lr(nzb:nzt+1,nys:nyn,iawbc)
+
+!      do  k = 0, 2
+!         do  j = nys, nyn 
+!            if  ( edge == 'l' )  then
+!               write(9,"('lr5: ',2(a2,2x),4(i4,2x),4(e12.5,2x))") edge, var, k, j, ibc, iawbc,  &
+!                    workarr_lr(k,j,iawbc), f(k,j,ibc), f(k,j,ibc+1), f(k,j,ibc+2)
+!            else if  ( edge == 'r' )  then
+!               write(9,"('lr5: ',2(a2,2x),4(i4,2x),4(e12.5,2x))") edge, var, k, j, ibc, iawbc,  &
+!                    f(k,j,ibc-2), f(k,j,ibc-1), f(k,j,ibc), workarr_lr(k,j,iawbc)
+!            endif
+!         enddo
+!      enddo
+!      flush(9)
 
    END SUBROUTINE pmci_interp_tril_lr
@@ -5754,14 +7000,18 @@
       REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nxl:nxr),          &
                                       INTENT(IN)    ::  logc_ratio    !<
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x           !<
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x           !<
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y           !<
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y           !<
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z           !<
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z           !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x           !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x           !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y           !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y           !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z           !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z           !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z           !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z           !<
+
       
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !<
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
+      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic    !<
+      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc    !<
+!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
+      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc    !<
       INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nxl:nxr),                &
                                           INTENT(IN)           ::  logc  !<
@@ -5769,8 +7019,15 @@
 
       INTEGER(iwp) :: kct
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+
 !AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
 !AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
@@ -5778,40 +7035,58 @@
       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
 !AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-
-      CHARACTER(LEN=1), INTENT(IN) ::  edge   !<
-      CHARACTER(LEN=1), INTENT(IN) ::  var    !<
+!AH
+!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+
+      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
+      CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
       
-      INTEGER(iwp) ::  i       !<
-      INTEGER(iwp) ::  iinc    !<
-      INTEGER(iwp) ::  icorr   !<
-      INTEGER(iwp) ::  ico     !<
-      INTEGER(iwp) ::  ijk     !<
-      INTEGER(iwp) ::  i1      !<
-      INTEGER(iwp) ::  j       !<
-      INTEGER(iwp) ::  ja      !<
-      INTEGER(iwp) ::  jb      !<
-      INTEGER(iwp) ::  jbgp    !<
-      INTEGER(iwp) ::  k       !<
-      INTEGER(iwp) ::  k_wall  !< vertical index of topography top
-      INTEGER(iwp) ::  kcorr   !<
-      INTEGER(iwp) ::  kco     !<
-      INTEGER(iwp) ::  k1      !<
-      INTEGER(iwp) ::  l       !<
-      INTEGER(iwp) ::  m       !<
-      INTEGER(iwp) ::  n       !<
-      INTEGER(iwp) ::  var_flag !<
-
-      REAL(wp) ::  cellsum     !<
-      REAL(wp) ::  cellsumd    !<
-      REAL(wp) ::  fk          !<
-      REAL(wp) ::  fkj         !<
-      REAL(wp) ::  fkjp        !<
-      REAL(wp) ::  fkpj        !<
-      REAL(wp) ::  fkpjp       !<
-      REAL(wp) ::  fkp         !<
-      REAL(wp) ::  rcorr       !< 
-      REAL(wp) ::  rcorr_ijk   !< 
-      
+      INTEGER(iwp) ::  i        !< Running index in the x-direction
+      INTEGER(iwp) ::  iinc     !<
+      INTEGER(iwp) ::  icorr    !<
+      INTEGER(iwp) ::  ico      !<
+      INTEGER(iwp) ::  ierr     !< MPI error code
+      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
+      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
+      INTEGER(iwp) ::  i1       !<
+      INTEGER(iwp) ::  j        !< Lower bound of the running index ja
+      INTEGER(iwp) ::  ja       !< Index in y-direction running over the parent-grid cell on the boundary 
+      INTEGER(iwp) ::  jaw      !< Reduced ja-index for workarr_sn
+      INTEGER(iwp) ::  jawbc    !< jaw-index pointing to the boundary-value nodes (either 0 or jgsr-1)
+!AH      INTEGER(iwp) ::  jbeg     !< j-index pointing to the starting point of workarr_sn in the j-direction
+      INTEGER(iwp) ::  jbc      !< Fixed j-index pointing to the boundary-value nodes (either j or jend)
+      INTEGER(iwp) ::  jend     !< Upper bound of the running index ja
+      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
+      INTEGER(iwp) ::  k        !< Running index in the z-direction
+      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
+      INTEGER(iwp) ::  kcorr    !<
+      INTEGER(iwp) ::  kco      !<
+      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
+      INTEGER(iwp) ::  k1       !<
+      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
+      INTEGER(iwp) ::  lp1      !< l+1
+      INTEGER(iwp) ::  lrightu  !< Upshift by one for the upper bound of index l in case of var == 'u'
+      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
+      INTEGER(iwp) ::  mbeg     !< m-index pointing to the starting point of workarrc_sn in the m-direction 
+      INTEGER(iwp) ::  moff     !< m-offset needed on the north boundary to correctly refer to boundary ghost points
+      INTEGER(iwp) ::  mp1      !< m+1
+      INTEGER(iwp) ::  mw       !< Reduced m-index for workarrc_sn
+      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
+      INTEGER(iwp) ::  np1      !< n+1
+      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
+      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
+
+      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
+      REAL(wp) ::  cellsumd     !< Sum of differences over the anterpolation cell 
+      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
+      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
+
 !
 !--   Check which edge is to be handled: south or north
@@ -5820,13 +7095,46 @@
 !--      For v, nys is a ghost node, but not for the other variables
          IF ( var == 'v' )  THEN
-            j  = nys
-            jb = nys - 1 
+            j     = nys
+            jend  = nys 
+            jawbc = 0
+            jbc   = nys       
+            mbeg  = jcs
+            moff  = 0
          ELSE
-            j  = nys - 1
-            jb = nys - 2
+            j     = nys - jgsr
+            jend  = nys - 1
+            jawbc = jgsr - 1
+            jbc   = nys - 1
+            mbeg  = jcs
+            moff  = 0
          ENDIF
       ELSEIF ( edge == 'n' )  THEN
-         j  = nyn + 1
-         jb = nyn + 2
+         IF ( var == 'v' )  THEN
+            j     = nyn + 1
+            jend  = nyn + 1
+            jawbc = 0
+            jbc   = nyn + 1
+            mbeg  = jcn - 2
+            moff  = 0
+         ELSE
+            j     = nyn + 1
+            jend  = nyn + jgsr
+            jawbc = 0
+            jbc   = nyn + 1
+            mbeg  = jcn - 2
+            moff  = 1
+         ENDIF
+      ENDIF
+
+      IF  ( var == 'w' )  THEN
+         ntopw = 1
+      ELSE
+         ntopw = 0
+      ENDIF
+
+      IF  ( var == 'u' )  THEN
+         lrightu = 0
+      ELSE
+         lrightu = 1
       ENDIF
 
@@ -5840,23 +7148,87 @@
          var_flag = 0
       ENDIF
-
-      DO  i = nxl, nxr+1
-!
-!--      Determine vertical index of topography top at grid point (j,i)
-!AH         k_wall = get_topography_top_index_ji( j, i, TRIM( var ) )
-
-         DO  k = nzb, nzt+1 !AH k_wall, nzt+1
-            l = ic(i)
-            m = jc(j)
-            n = kc(k)              
-            fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
-            fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
-            fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
-            fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
-            fk       = r1y(j) * fkj  + r2y(j) * fkjp
-            fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
-            f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
+!AH
+!
+!--   Substitute the necessary parent-grid data to the work array workarrc_sn. 
+      workarrc_sn = 0.0_wp     
+      IF  ( pdims(1) > 1 )  THEN
+#if defined( __parallel )
+         IF  ( nxl == 0 )  THEN   ! if ( bc_dirichlet_l )
+            workarrc_sn(0:cg%nz+1,0:2,iclw:icrw-1)                              &
+                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw:icrw-1)
+         ELSE IF  ( nxr == nx )  THEN    ! if ( bc_dirichlet_r )
+            workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw)                              &
+                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw)
+         ELSE
+            workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw-1)                            &
+                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw-1)
+         ENDIF
+!
+!--      Left-right exchange if more than one PE subdomain in the x-direction.
+!--      Note that in case of 3-D nesting the left (pleft == MPI_PROC_NULL) and 
+!--      right (pright == MPI_PROC_NULL) boundaries are not exchanged because 
+!--      the nest domain is not cyclic.
+!--      From left to right
+         CALL MPI_SENDRECV( workarrc_sn(0,0,iclw+1), 1,                         &
+              workarrc_sn_exchange_type, pleft,   0,                            &
+              workarrc_sn(0,0,icrw), 1,                                         &
+              workarrc_sn_exchange_type, pright,  0,                            &
+              comm2d, status, ierr ) 
+!
+!--      From right to left        
+         CALL MPI_SENDRECV( workarrc_sn(0,0,icrw-1), 1,                         &
+              workarrc_sn_exchange_type, pright,  1,                            &
+              workarrc_sn(0,0,iclw), 1,                                         &
+              workarrc_sn_exchange_type, pleft,   1,                            &
+              comm2d, status, ierr )
+#endif      
+      ELSE
+         workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw-1)                               &
+                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw-1)
+      ENDIF
+!
+!AH
+
+      workarr_sn = 0.0_wp
+      
+      DO  i = nxl-1, nxr+1
+!AH      DO  i = nxl, nxr
+         DO  ja = j, jend
+            jaw = ja - j
+            DO  k = nzb, nzt+1
+               l   = ic(i)
+               lp1 = MIN( l + 1, icrw )  ! If l+1 > icr (l=ic(nxr+1)), r1x = 1 and r2x = 0
+!AH               m   = jc(ja) - jc(j)
+               m   = jc(ja) - mbeg
+               mp1 = MIN( m + 1, 2 )  ! If m+1 > 2 (m=jc(nyn+1)-mbeg), r1y = 1 and r2y = 0
+               n   = kc(k)
+               np1 = n + 1
+!AH
+!               fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
+!               fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
+!               fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
+!               fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
+!AH
+               fkj      = r1x(i) * workarrc_sn(n,m,l)     + r2x(i) * workarrc_sn(n,m,lp1)
+               fkjp     = r1x(i) * workarrc_sn(n,mp1,l)   + r2x(i) * workarrc_sn(n,mp1,lp1)
+               fkpj     = r1x(i) * workarrc_sn(np1,m,l)   + r2x(i) * workarrc_sn(np1,m,lp1)
+               fkpjp    = r1x(i) * workarrc_sn(np1,mp1,l) + r2x(i) * workarrc_sn(np1,mp1,lp1)
+
+               fk       = r1y(ja) * fkj  + r2y(ja) * fkjp
+               fkp      = r1y(ja) * fkpj + r2y(ja) * fkpjp
+!AH
+!               f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
+               workarr_sn(k,jaw,i) = r1z(k) * fk   + r2z(k) * fkp
+
+!               if  ( ( edge == 's' ) .and. ( ja  == jbc ) ) then
+!                  write(9,"('pmci_interp_tril_sn: ',a2,2x,11(i4,2x),1(e12.5,2x))") var, k, ja, i, jbc, jaw, n, m, l, np1, mp1, lp1, &
+!                       workarr_sn(k,jaw,i)
+!                  flush(9)
+!               endif
+
+!AH               
+            ENDDO
          ENDDO
-      ENDDO
+      ENDDO      
 !
 !--   Generalized log-law-correction algorithm.
